=== debian/changelog ===
openio-sds (4.1.26-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Wed, 20 Jun 2018 09:42:12 +0000

openio-sds (4.1.25-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Wed, 13 Jun 2018 09:21:44 +0000

openio-sds (4.1.24-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Mon, 04 Jun 2018 16:18:32 +0000

openio-sds (4.1.23-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Mon, 28 May 2018 12:15:56 +0000

openio-sds (4.1.22-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Tue, 24 Apr 2018 15:48:41 +0000

openio-sds (4.1.21-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Tue, 03 Apr 2018 15:36:27 +0000

openio-sds (4.1.18-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Tue, 27 Mar 2018 08:45:23 +0000

openio-sds (4.1.17-1) xenial; urgency=medium

  * New release

 -- Vincent Legoll <vincent.legoll@openio.io>  Mon, 26 Mar 2018 15:41:56 +0000

openio-sds (4.0.0-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 30 Jun 2017 17:15:42 +0000

openio-sds (3.3.1-2) xenial; urgency=medium

  * Fix the PBR version

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 16 Jun 2017 17:14:59 +0000

openio-sds (3.3.1-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 16 Jun 2017 17:02:50 +0000

openio-sds (3.3.0-1) xenial; urgency=medium

  * New release
  * Change python to C for rdir 

 -- Sebastien Lapierre <sebastien.lapierre@openio.io>  Fri, 12 May 2017 15:19:26 +0000
